package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import java.util.Arrays;
import java.util.List;

public class ExampleMain {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistEntity();
            loadEntity();
            loadEntity2();
        } finally {
            entityManagerFactory.close();
        }
    }

    public static void persistEntity() {
        Employee employee = new Employee();
        employee.setName("Megan");
        employee.setDept("Admin");
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
    }

    private static void loadEntity() {
        EntityManager em = entityManagerFactory.createEntityManager();
        Map<String, Object> properties = new HashMap<>();
        properties.put("javax.persistence.cache.storeMode", CacheRetrieveMode.BYPASS);
        Employee employee = em.find(Employee.class, 1L, properties);
        System.out.println("Employee loaded: " + employee);
        em.close();
    }
}